class AkkordArbeider extends Ansatt {

  // Nye egenskaper
  private double prisPerEnhet;
  private int antallEnheter;

  // Konstruktrer
  public AkkordArbeider() { /* Standard verdier for alle felt. */ }

  public AkkordArbeider(String fNavn, String eNavn, boolean kjnn,
                        double pris, int antall) {
    super(fNavn, eNavn, 0.0, kjnn); // superklassens konstruktr
    prisPerEnhet = pris;
    antallEnheter = antall;
  }

  @Override
  public String toString() {
    return super.toString()
         + "\nblir betalt " + String.format("%.2f", prisPerEnhet) + " per enhet"
         + ", og har solgt " + antallEnheter + " enheter.";
  }

  @Override
  public double beregnUkelnn(double antallTimer) {  // ignorer innparameter
    return antallEnheter * prisPerEnhet;
  }

  // Nye instansmetoder
  public double beregnUkelnn() {                    // forandrer kontrakt
    return antallEnheter * prisPerEnhet;
  }

  public void settPrisPerEnhet(double pris) { prisPerEnhet = pris; }
  public double hentPrisPerEnhet()          { return prisPerEnhet; }
  public void settAntallEnheter(int antall) { antallEnheter = antall; }
  public int hentAntallEnheter()            { return antallEnheter; }
}