import java.io.Serializable;

class Ansatt implements Serializable {
  // Konstanter
  final static boolean MANN   = false;
  final static boolean KVINNE = true;
  final static double  NORMAL_ARBEIDSUKE = 37.5;

  // Feltvariabler
  private String  fornavn;
  private String  etternavn;
  private double  timelnn;
  private boolean kjnn;

  // Konstruktrer
  Ansatt() { /* Lar alle attributter f standardverdier */ }

  Ansatt(String fornavn, String etternavn, double timelnn, boolean kjnn) {
    this.fornavn = fornavn;
    this.etternavn = etternavn;
    this.timelnn = timelnn;
    this.kjnn = kjnn;
  }

  // Instansmetoder
  void settFornavn(String fNavn)      { fornavn   = fNavn; }
  void settEtternavn(String eNavn)    { etternavn = eNavn; }
  void settTimelnn(double lnn)      { timelnn  = lnn; }
  void settKjnn(boolean angittKjnn) { kjnn     = angittKjnn; }

  String hentFornavn()   { return fornavn; }
  String hentEtternavn() { return etternavn; }
  double hentTimelnn()  { return timelnn; }
  boolean hentKjnn()    { return kjnn; }

  boolean erMann()   { return (kjnn == MANN); }
  boolean erKvinne() { return (kjnn == KVINNE); }

  double beregnUkelnn(double antallTimer) {
    if (antallTimer < 0) {
      System.out.println("Antall timer m vre >= 0: " + antallTimer);
      return 0.0;
    }
    double ukelnn = antallTimer * timelnn;
    if (antallTimer >= Ansatt.NORMAL_ARBEIDSUKE) {
      double overtid = antallTimer - NORMAL_ARBEIDSUKE;
      ukelnn += 2.0 * timelnn * overtid;
    }
    return ukelnn;
  }

  @Override
  public String toString() {
    String kjnnInfo;
    if (kjnn)
      kjnnInfo = "kvinne";
    else
      kjnnInfo = "mann";

    return String.format("Fornavn: %-8s Etternavn: %-8s Timelnn: %6.2f " +
                         "Kjnn: %-6s", fornavn, etternavn, timelnn, kjnnInfo);
  }
}
