/*
 * Lister alle filer under en (oppgitt) katalog
 */
import java.io.*;

public class KatalogListe {
  public static void listKatalog(File fil) {
    try {
      if (!fil.exists()) {
        System.out.println(fil.getCanonicalPath() + " finnes ikke.");
      } else if (fil.isFile()) {
        System.out.println(fil.getCanonicalPath());
      } else { // katalog
        String[] filNavn = fil.list();
        for (int i = 0; i < filNavn.length; i++) {
          File tf = new File(fil.getPath(), filNavn[i]);
          listKatalog(tf);
        }
      }
    }
    catch (IOException e) { System.out.println("Feil: " + e); }
  }

  public static void main(String args[]) {
    File fil;
    if (args.length == 0)
      fil = new File("..");  // Bruk foreldre-katalog
    else
      fil = new File(args[0]);
    listKatalog(fil);
  }
} // slutt klasse KatalogListe
