import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class SerialiseringUtenDuplisering {

  public static void main(String[] args) {

    // Opprett en del rd.                                                  (1)
    StringBuilder spesieltRd = new StringBuilder("Vr forsiktig med hva du sier");
    StringBuilder[] rdTabell = {
        spesieltRd, // Felles rd.                                         (2)
        new StringBuilder("Vr forsiktig med hva du hrer"),
        new StringBuilder("Vr forsiktig med hva du ser")
    };

    String datafilnavn = "raad.data";

    try (
        // Opprett strmmer for serialisering.                                (3)
        FileOutputStream utFilStrm = new FileOutputStream(datafilnavn, false);
        BufferedOutputStream bufretUtStrm = new BufferedOutputStream(utFilStrm); // (3a)
        ObjectOutputStream utObjStrm = new ObjectOutputStream(bufretUtStrm) ) {

      // Skriv rd-tabell og spesielt rd to ganger.                        (4)
      utObjStrm.writeObject(rdTabell);
      utObjStrm.writeObject(spesieltRd);
      utObjStrm.writeObject(rdTabell);
      utObjStrm.writeObject(spesieltRd);
    }
    catch (IOException unntak) {
      System.out.print("Feil p filen: " + unntak);
    }

    try (
        // Opprett strmmer for deserialisering.                              (5)
        FileInputStream innFilStrm = new FileInputStream(datafilnavn);
        BufferedInputStream bufretInnStrm = new BufferedInputStream(innFilStrm);
        ObjectInputStream innObjStrm = new ObjectInputStream(bufretInnStrm) ) {

      // Les alle serialiserte objekter i riktig rekkeflge.                (6)
      StringBuilder rdTabell1[] = (StringBuilder[])innObjStrm.readObject();
      StringBuilder spesieltRd1 = (StringBuilder)  innObjStrm.readObject();
      StringBuilder rdTabell2[] = (StringBuilder[])innObjStrm.readObject();
      StringBuilder spesieltRd2 = (StringBuilder)  innObjStrm.readObject();

      // Test om to referanser er like,dvs. om de betegner samme objekt.    (7)
      System.out.println("rdTabell og rdTabell1 betegner samme objekt: "
          + (rdTabell == rdTabell1));
      System.out.println("spesieltRd og rdTabell1[0] betegner samme objekt: "
          + (spesieltRd == rdTabell1[0]));
      System.out.println("rdTabell1 og rdTabell2 betegner samme objekt: "
          + (rdTabell1 == rdTabell2));
      System.out.println("spesieltRd1 og spesieltRd2 betegner samme objekt: "
          + (spesieltRd1 == spesieltRd2));
      System.out.println("rdTabell1[0] og rdTabell2[0] betegner samme objekt: "
          + (rdTabell1[0] == rdTabell2[0]));
      System.out.println("rdTabell1[0] og spesieltRd2 betegner samme objekt: "
          + (rdTabell1[0] == spesieltRd2));

      // Test om objektene er like.                                         (8)
      System.out.println("Objektene som referansene spesieltRd og " +
          "rdTabell1[0] betegner har samme tilstand: "
          + spesieltRd.toString().equals(rdTabell1[0].toString()));
    }
    catch (IOException unntak) {
      System.out.print("Feil p filen: " + unntak);
    }
    catch (ClassNotFoundException unntak) {
      System.out.print("Klassedefinisjon ikke funnet: " + unntak);
    }
  }
}