import java.util.InputMismatchException;
import java.util.Scanner;

public final class Tastatur {
  private Tastatur() {}; // Kan ikke opprette et objekt av denne klassen.

  // Scanner-objektet som er koblet til System.in-objektet.
  private static Scanner tastatur = new Scanner(System.in);

  /**
   * Leser en int verdi fra tastatur.
   */
  public static int lesHeltall() {
    while (true)
      try {
        return tastatur.nextInt();
      } catch (InputMismatchException ime) {
        rapporterFeil();
      }
  }

  /**
   * Leser en double verdi fra tastatur.
   */
  public static double lesFlyttall() {
    while (true)
      try {
        return tastatur.nextDouble();
      } catch (InputMismatchException ime) {
        rapporterFeil();
      }
  }

  /**
   * Leser en streng fra tastatur.
   */
  public static String lesStreng() {
    while (true)
      try {
        return tastatur.next();
      } catch (InputMismatchException ise) {
        rapporterFeil();
      }
  }

  /**
   * Leser alt som mtte vre igjen (dvs. ikke er lest) i den innevrende linjen
   * og returnerer dette som et objekt av typen String.
   */
  public static String lesLinje() {
    while (true)
      try {
        return tastatur.nextLine();
      } catch (InputMismatchException ise) {
        rapporterFeil();
      }
  }

  /**
   * Skriver feilmelding og gr videre til neste linje i terminalvinduet, slik at
   * brukeren kan taste inn verdi p nytt.
   */
  private static void rapporterFeil() {
    tastatur.nextLine(); // Tm linjen frst.
    System.out.println("Feil i inndata. Prv p nytt!");
  }
}